diff -ruN ccp4srs-old/ccp4srs/ccp4srs_tree.cpp ccp4srs/ccp4srs/ccp4srs_tree.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_tree.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_tree.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_tree.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_tree.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,206 +22,206 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_tree  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSTree  - structure tree
+//  **** Classes :  ccp4srs::Tree  - structure tree
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
 
-
-#ifndef  __STRING_H
 #include <string.h>
-#endif
 
 #include "ccp4srs_tree.h"
 #include "ccp4srs_defs.h"
 
-CCP4SRSTree::CCP4SRSTree()  {
-  n_sections    = 0;
-  atom_tree     = NULL;  // tree atom
-  atom_backward = NULL;  // previous atom
-  atom_forward  = NULL;  // next atom
-  connect_type  = NULL;  // type of connection
-}
-
-CCP4SRSTree::~CCP4SRSTree()  {
-  empty();
-}
-
-void CCP4SRSTree::empty()  {
-  FreeVectorMemory ( atom_tree    ,0 );
-  FreeVectorMemory ( atom_backward,0 );
-  FreeVectorMemory ( atom_forward ,0 );
-  n_sections = 0;
-}
-
-
-int CCP4SRSTree::readFromCIF ( PCMMCIFLoop mmCIFLoop,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-pstr p;
-int  rc,i;
+namespace ccp4srs  {
 
-  rc = 0;
+  Tree::Tree()  {
+    n_sections    = 0;
+    atom_tree     = NULL;  // tree atom
+    atom_backward = NULL;  // previous atom
+    atom_forward  = NULL;  // next atom
+    connect_type  = NULL;  // type of connection
+  }
 
-  empty();
+  Tree::~Tree()  {
+    empty();
+  }
 
-  if (mmCIFLoop)  {
+  void Tree::empty()  {
+    mmdb::FreeVectorMemory ( atom_tree    ,0 );
+    mmdb::FreeVectorMemory ( atom_backward,0 );
+    mmdb::FreeVectorMemory ( atom_forward ,0 );
+    n_sections = 0;
+  }
 
-    n_sections = mmCIFLoop->GetLoopLength();
 
-    if (n_sections>0)  {
+  int Tree::readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                          Container<Atom> & atoms ) {
+  mmdb::pstr p;
+  int        rc,i;
+
+    rc = 0;
+
+    empty();
+
+    if (mmCIFLoop)  {
+
+      n_sections = mmCIFLoop->GetLoopLength();
+
+      if (n_sections>0)  {
+
+        mmdb::GetVectorMemory ( atom_tree,    n_sections,0 );
+        mmdb::GetVectorMemory ( atom_backward,n_sections,0 );
+        mmdb::GetVectorMemory ( atom_forward, n_sections,0 );
+        mmdb::GetVectorMemory ( connect_type, n_sections,0 );
+        for (i=0;(i<n_sections) && (!rc);i++)  {
+          get_atom_from_cif ( atom_tree[i],mmCIFLoop,
+                              MMCIF_TAG_ATOM_ID,i,atoms,rc );
+          get_atom_from_cif ( atom_backward[i],mmCIFLoop,
+                              MMCIF_TAG_ATOM_BACK,i,atoms,rc );
+          get_atom_from_cif ( atom_forward[i],mmCIFLoop,
+                              MMCIF_TAG_ATOM_FORWARD,i,atoms,rc );
+          p = mmCIFLoop->GetString ( MMCIF_TAG_CONNECT_TYPE,i,rc );
+          if (!p)   connect_type[i] = Tree::None;
+          else if (!strcmp(p,"START"))
+                    connect_type[i] = Tree::Start;
+          else if (!strcmp(p,"END"))
+                    connect_type[i] = Tree::End;
+          else if (!strcmp(p,"ADD"))
+                    connect_type[i] = Tree::Add;
+          else      connect_type[i] = Tree::None;
+        }
 
-      GetVectorMemory ( atom_tree,    n_sections,0 );
-      GetVectorMemory ( atom_backward,n_sections,0 );
-      GetVectorMemory ( atom_forward, n_sections,0 );
-      GetVectorMemory ( connect_type, n_sections,0 );
-      for (i=0;(i<n_sections) && (!rc);i++)  {
-        get_atom_from_cif ( atom_tree[i],mmCIFLoop,
-                            MMCIF_TAG_ATOM_ID,i,atoms,rc );
-        get_atom_from_cif ( atom_backward[i],mmCIFLoop,
-                            MMCIF_TAG_ATOM_BACK,i,atoms,rc );
-        get_atom_from_cif ( atom_forward[i],mmCIFLoop,
-                            MMCIF_TAG_ATOM_FORWARD,i,atoms,rc );
-        p = mmCIFLoop->GetString ( MMCIF_TAG_CONNECT_TYPE,i,rc );
-        if (!p)   connect_type[i] = CCP4SRSTree::None;
-        else if (!strcmp(p,"START"))
-                  connect_type[i] = CCP4SRSTree::Start;
-        else if (!strcmp(p,"END"))
-                  connect_type[i] = CCP4SRSTree::End;
-        else if (!strcmp(p,"ADD"))
-                  connect_type[i] = CCP4SRSTree::Add;
-        else      connect_type[i] = CCP4SRSTree::None;
       }
 
     }
 
-  }
-
-  return rc;
+    return rc;
 
-}
+  }
 
-void  CCP4SRSTree::writeToCIF ( PCMMCIFData mmCIFData, cpstr monID,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-PCMMCIFLoop loop;
-int         i;
+  void  Tree::writeToCIF ( mmdb::mmcif::PData mmCIFData,
+                           mmdb::cpstr monID,
+                           Container<Atom> & atoms )  {
+  mmdb::mmcif::PLoop loop;
+  int                i;
 
-  if (n_sections>0)  {
+    if (n_sections>0)  {
 
-    mmCIFData->AddLoop ( MMCIF_LOOP_CHEM_COMP_TREE,loop );
+      mmCIFData->AddLoop ( MMCIF_LOOP_CHEM_COMP_TREE,loop );
 
-    loop->AddLoopTag ( MMCIF_TAG_COMP_ID      );
-    loop->AddLoopTag ( MMCIF_TAG_ATOM_ID      );
-    loop->AddLoopTag ( MMCIF_TAG_ATOM_BACK    );
-    loop->AddLoopTag ( MMCIF_TAG_ATOM_FORWARD );
-    loop->AddLoopTag ( MMCIF_TAG_CONNECT_TYPE );
+      loop->AddLoopTag ( MMCIF_TAG_COMP_ID      );
+      loop->AddLoopTag ( MMCIF_TAG_ATOM_ID      );
+      loop->AddLoopTag ( MMCIF_TAG_ATOM_BACK    );
+      loop->AddLoopTag ( MMCIF_TAG_ATOM_FORWARD );
+      loop->AddLoopTag ( MMCIF_TAG_CONNECT_TYPE );
 
-    for (i=0;i<n_sections;i++)  {
-      loop->AddString ( monID,False );
-      add_atom_to_cif ( loop, atom_tree    [i], atoms );
-      add_atom_to_cif ( loop, atom_backward[i], atoms );
-      add_atom_to_cif ( loop, atom_forward [i], atoms );
-      switch (connect_type[i])  {
-        default :
-        case CCP4SRSTree::None  : loop->AddNoData ( CIF_NODATA_DOT );
-                                  break;
-        case CCP4SRSTree::Start : loop->AddString ( "START",False );
-                                  break;
-        case CCP4SRSTree::End   : loop->AddString ( "END",False );
-                                  break;
-        case CCP4SRSTree::Add   : loop->AddString ( "ADD",False );
+      for (i=0;i<n_sections;i++)  {
+        loop->AddString ( monID,false );
+        add_atom_to_cif ( loop, atom_tree    [i], atoms );
+        add_atom_to_cif ( loop, atom_backward[i], atoms );
+        add_atom_to_cif ( loop, atom_forward [i], atoms );
+        switch (connect_type[i])  {
+          default :
+          case Tree::None  : loop->AddNoData ( mmdb::mmcif::CIF_NODATA_DOT );
+                                    break;
+          case Tree::Start : loop->AddString ( "START",false );
+                                    break;
+          case Tree::End   : loop->AddString ( "END",false );
+                                    break;
+          case Tree::Add   : loop->AddString ( "ADD",false );
+        }
       }
+
     }
 
   }
 
-}
+  /*
+  loop_
+  _chem_comp_tree.comp_id
+  _chem_comp_tree.atom_id
+  _chem_comp_tree.atom_back
+  _chem_comp_tree.atom_forward
+  _chem_comp_tree.connect_type
+   ATP      O2A    n/a    PA     START
+
+  */
+
+
+  void  Tree::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+  int i;
+    memIO->put_integer ( n_sections );
+    for (i=0;i<n_sections;i++)  {
+      memIO->put_integer ( atom_tree    [i] );
+      memIO->put_integer ( atom_backward[i] );
+      memIO->put_integer ( atom_forward [i] );
+      memIO->put_integer ( connect_type [i] );
+    }
+  }
 
-/*
-loop_
-_chem_comp_tree.comp_id
-_chem_comp_tree.atom_id
-_chem_comp_tree.atom_back
-_chem_comp_tree.atom_forward
-_chem_comp_tree.connect_type
- ATP      O2A    n/a    PA     START
-
-*/
-
-
-void  CCP4SRSTree::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
-int i;
-  memIO->put_integer ( n_sections );
-  for (i=0;i<n_sections;i++)  {
-    memIO->put_integer ( atom_tree    [i] );
-    memIO->put_integer ( atom_backward[i] );
-    memIO->put_integer ( atom_forward [i] );
-    memIO->put_integer ( connect_type [i] );
-  }
-}
-
-void  CCP4SRSTree::copy ( PCCP4SRSTree tree, ivector anmatch )  {
-int i;
-  empty();
-  n_sections = tree->size();
-  if (n_sections>0)  {
-    GetVectorMemory ( atom_tree,    n_sections,0 );
-    GetVectorMemory ( atom_backward,n_sections,0 );
-    GetVectorMemory ( atom_forward, n_sections,0 );
-    GetVectorMemory ( connect_type, n_sections,0 );
-    if (anmatch)  {
-      for (i=0;i<n_sections;i++)  {
-        if (tree->atom(i)>=0)
-          atom_tree    [i] = anmatch [ tree->atom    (i) ];
-        if (tree->backward(i)>=0)
-          atom_backward[i] = anmatch [ tree->backward(i) ];
-        if (tree->forward(i)>=0)
-          atom_forward [i] = anmatch [ tree->forward (i) ];
-        connect_type [i] = tree->connect (i);
-      }
-    } else  {
-      for (i=0;i<n_sections;i++)  {
-        atom_tree    [i] = tree->atom    (i);
-        atom_backward[i] = tree->backward(i);
-        atom_forward [i] = tree->forward (i);
-        connect_type [i] = tree->connect (i);
+  void  Tree::copy ( PTree tree, mmdb::ivector anmatch )  {
+  int i;
+    empty();
+    n_sections = tree->size();
+    if (n_sections>0)  {
+      mmdb::GetVectorMemory ( atom_tree,    n_sections,0 );
+      mmdb::GetVectorMemory ( atom_backward,n_sections,0 );
+      mmdb::GetVectorMemory ( atom_forward, n_sections,0 );
+      mmdb::GetVectorMemory ( connect_type, n_sections,0 );
+      if (anmatch)  {
+        for (i=0;i<n_sections;i++)  {
+          if (tree->atom(i)>=0)
+            atom_tree    [i] = anmatch [ tree->atom    (i) ];
+          if (tree->backward(i)>=0)
+            atom_backward[i] = anmatch [ tree->backward(i) ];
+          if (tree->forward(i)>=0)
+            atom_forward [i] = anmatch [ tree->forward (i) ];
+          connect_type [i] = tree->connect (i);
+        }
+      } else  {
+        for (i=0;i<n_sections;i++)  {
+          atom_tree    [i] = tree->atom    (i);
+          atom_backward[i] = tree->backward(i);
+          atom_forward [i] = tree->forward (i);
+          connect_type [i] = tree->connect (i);
+        }
       }
     }
   }
-}
 
 
-Boolean  CCP4SRSTree::read_mem ( PCMemIO memIO, int version,
-                                 Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-int     i;
-Boolean success;
-  empty();
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_integer ( n_sections,&success );
-  if (n_sections>0)  {
-    GetVectorMemory ( atom_tree,    n_sections,0 );
-    GetVectorMemory ( atom_backward,n_sections,0 );
-    GetVectorMemory ( atom_forward, n_sections,0 );
-    GetVectorMemory ( connect_type, n_sections,0 );
-    for (i=0;i<n_sections;i++)  {
-      memIO->get_integer ( atom_tree    [i],&success );
-      memIO->get_integer ( atom_backward[i],&success );
-      memIO->get_integer ( atom_forward [i],&success );
-      memIO->get_integer ( connect_type [i],&success );
+  bool  Tree::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  int  i;
+  bool success;
+    empty();
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_integer ( n_sections,&success );
+    if (n_sections>0)  {
+      mmdb::GetVectorMemory ( atom_tree,    n_sections,0 );
+      mmdb::GetVectorMemory ( atom_backward,n_sections,0 );
+      mmdb::GetVectorMemory ( atom_forward, n_sections,0 );
+      mmdb::GetVectorMemory ( connect_type, n_sections,0 );
+      for (i=0;i<n_sections;i++)  {
+        memIO->get_integer ( atom_tree    [i],&success );
+        memIO->get_integer ( atom_backward[i],&success );
+        memIO->get_integer ( atom_forward [i],&success );
+        memIO->get_integer ( connect_type [i],&success );
+      }
     }
+    if (Ok)  *Ok = success;
+    return success;
   }
-  if (Ok)  *Ok = success;
-  return success;
-}
 
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_tree.h ccp4srs/ccp4srs/ccp4srs_tree.h
--- ccp4srs-old/ccp4srs/ccp4srs_tree.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_tree.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_tree.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_tree.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_tree  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSTree  - structure tree
+//  **** Classes :  ccp4srs::Tree  - structure tree
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -41,43 +41,48 @@
 
 #include "ccp4srs_atom.h"
 
-DefineClass(CCP4SRSTree);
+namespace ccp4srs  {
 
-class CCP4SRSTree  {
+  DefineClass(Tree);
 
-  // atom connectivity types
-  enum  {None,Start,End,Add};
+  class Tree  {
 
-  public:
-    CCP4SRSTree();
-    virtual ~CCP4SRSTree();
+    // atom connectivity types
+    enum  {None,Start,End,Add};
 
-    void  empty();
+    public:
+      Tree();
+      virtual ~Tree();
 
-    inline int size() { return n_sections;    }
-    inline int atom     ( int secNo ) { return atom_tree    [secNo]; }
-    inline int backward ( int secNo ) { return atom_backward[secNo]; }
-    inline int forward  ( int secNo ) { return atom_forward [secNo]; }
-    inline int connect  ( int secNo ) { return connect_type [secNo]; }
+      void  empty();
 
-    int   readFromCIF   ( PCMMCIFLoop mmCIFLoop,
-                          CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    void  writeToCIF    ( PCMMCIFData mmCIFData, cpstr monID,
-                          CCP4SRSContainer<CCP4SRSAtom> & atoms );
+      inline int size() { return n_sections;    }
+      inline int atom     ( int secNo ) { return atom_tree    [secNo]; }
+      inline int backward ( int secNo ) { return atom_backward[secNo]; }
+      inline int forward  ( int secNo ) { return atom_forward [secNo]; }
+      inline int connect  ( int secNo ) { return connect_type [secNo]; }
 
-    void    write_mem   ( PCMemIO memIO, int version );
-    Boolean read_mem    ( PCMemIO memIO, int version,
-                          Boolean * Ok = NULL );
+      int   readFromCIF   ( mmdb::mmcif::PLoop mmCIFLoop,
+                            Container<Atom> & atoms );
+      void  writeToCIF    ( mmdb::mmcif::PData mmCIFData,
+                            mmdb::cpstr monID,
+                            Container<Atom> & atoms );
 
-    void  copy ( PCCP4SRSTree tree, ivector anmatch=NULL );
+      void  write_mem   ( PMemIO memIO, int version );
+      bool  read_mem    ( PMemIO memIO, int version,
+                          bool * Ok = NULL );
 
-  protected:
-    int      n_sections;     //!< number of sections
-    ivector  atom_tree;      //!< tree atom name
-    ivector  atom_backward;  //!< previous atom name
-    ivector  atom_forward;   //!< next atom name
-    ivector  connect_type;   //!< type of connection
+      void  copy ( PTree tree, mmdb::ivector anmatch=NULL );
 
-};
+    protected:
+      int            n_sections;     //!< number of sections
+      mmdb::ivector  atom_tree;      //!< tree atom name
+      mmdb::ivector  atom_backward;  //!< previous atom name
+      mmdb::ivector  atom_forward;   //!< next atom name
+      mmdb::ivector  connect_type;   //!< type of connection
+
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_TREE_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_types.cpp ccp4srs/ccp4srs/ccp4srs_types.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_types.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_types.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_types.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_types.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,14 +22,15 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_types  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  SAtomPair  - atom pair
-//       ~~~~~~~~~  SDASelHnds - donor-acceptor selection handlers
+//  **** Classes :  ccp4srs::AtomPair  - atom pair
+//       ~~~~~~~~~  ccp4srs::DASelHnds - donor-acceptor selection
+//                                       handlers
 //
 //  (C) E. Krissinel 2010-2013
 //
@@ -38,22 +39,33 @@
 
 #include "ccp4srs_types.h"
 
-void SDASelHnds::getNewHandles ( PCMMDBManager MMDB )  {
-  selHndDonor    = MMDB->NewSelection();
-  selHndAcceptor = MMDB->NewSelection();
-  selHndHydrogen = MMDB->NewSelection();
-  selKey = SKEY_OR;
-}
-
-void SDASelHnds::makeSelIndexes ( PCMMDBManager MMDB )  {
-  MMDB->MakeSelIndex ( selHndDonor    );
-  MMDB->MakeSelIndex ( selHndAcceptor );
-  MMDB->MakeSelIndex ( selHndHydrogen );
-}
-
-void SDASelHnds::deleteSelections ( PCMMDBManager MMDB )  {
-  MMDB->DeleteSelection ( selHndDonor    );
-  MMDB->DeleteSelection ( selHndAcceptor );
-  MMDB->DeleteSelection ( selHndHydrogen );
-}
+namespace ccp4srs  {
 
+  const int CCP4SRS_file_version = 3;
+
+  mmdb::cpstr srsIndexFile  = "index.srs";
+  mmdb::cpstr srsGraphFile  = "graph.srs";
+  mmdb::cpstr srsStructFile = "struct.srs";
+
+  const int AtomID_NA = -10000;
+
+  void DASelHnds::getNewHandles ( mmdb::PManager MMDB )  {
+    selHndDonor    = MMDB->NewSelection();
+    selHndAcceptor = MMDB->NewSelection();
+    selHndHydrogen = MMDB->NewSelection();
+    selKey = mmdb::SKEY_OR;
+  }
+
+  void DASelHnds::makeSelIndexes ( mmdb::PManager MMDB )  {
+    MMDB->MakeSelIndex ( selHndDonor    );
+    MMDB->MakeSelIndex ( selHndAcceptor );
+    MMDB->MakeSelIndex ( selHndHydrogen );
+  }
+
+  void DASelHnds::deleteSelections ( mmdb::PManager MMDB )  {
+    MMDB->DeleteSelection ( selHndDonor    );
+    MMDB->DeleteSelection ( selHndAcceptor );
+    MMDB->DeleteSelection ( selHndHydrogen );
+  }
+
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_types.h ccp4srs/ccp4srs/ccp4srs_types.h
--- ccp4srs-old/ccp4srs/ccp4srs_types.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_types.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_types.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_types.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,17 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_types  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  SAtomPair  - atom pair
-//       ~~~~~~~~~  SDASelHnds - donor-acceptor selection handlers
+//  **** Classes :  ccp4srs::AtomPair  - atom pair
+//       ~~~~~~~~~  ccp4srs::DASelHnds - donor-acceptor selection
+//                                       handlers
 //
-//  (C) E. Krissinel 2010-2013
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
@@ -39,31 +40,71 @@
 #ifndef CCP4SRS_TYPES_H
 #define CCP4SRS_TYPES_H
 
+#include "mmdb2/mmdb_manager.h"
 
-#include "mmdb/mmdb_manager.h"
+namespace ccp4srs  {
 
-// ==================================================================
+  enum CCP4SRS_VERSION  {
+    MAJOR_VERSION = 1,  //!< major version
+    MINOR_VERSION = 0,  //!< minor version
+    MICRO_VERSION = 0   //!< micro version
+  };
+
+  extern const int CCP4SRS_file_version;
+
+  enum CCP4SRS_RC  {
+    CCP4SRS_noDonors         =   4,
+    CCP4SRS_noAcceptors      =   3,
+    CCP4SRS_noHBonds         =   2,
+    CCP4SRS_Incomplete       =   1,
+    CCP4SRS_Ok               =   0,
+    CCP4SRS_WrongBondType    =  -1,
+    CCP4SRS_IndexCorrupt     =  -2,
+    CCP4SRS_FileNotFound     =  -3,
+    CCP4SRS_EntryNotFound    =  -4,
+    CCP4SRS_ReadErrors       =  -5,
+    CCP4SRS_EmptyResidue     =  -6,
+    CCP4SRS_NoAtomsFound     =  -7,
+    CCP4SRS_NoBonds          =  -8,
+    CCP4SRS_EmptyResSet      =  -9,
+    CCP4SRS_Fail             = -10,
+    CCP4SRS_SVD_Fail         = -11,
+    CCP4SRS_noCoordHierarchy = -12,
+    CCP4SRS_BrokenBonds      = -13
+  };
+
+  extern mmdb::cpstr srsIndexFile;
+  extern mmdb::cpstr srsGraphFile;
+  extern mmdb::cpstr srsStructFile;
+
+
+  //  special atom ids
+  extern const int AtomID_NA;
+
+  // ==================================================================
+
+  DefineStructure(AtomPair);
+
+  struct AtomPair  {
+    mmdb::PAtom a1,a2;
+  };
+
+  // ==================================================================
+
+  //   SDASelHandles is optionally used in MakeBonds(..), when
+  // the latter works for hydrogen bond calculations.
+  DefineStructure(DASelHnds);
+
+  struct DASelHnds  {
+    int  selHndDonor;
+    int  selHndAcceptor;
+    int  selHndHydrogen;
+    mmdb::SELECTION_KEY selKey;
+    void getNewHandles    ( mmdb::PManager MMDB );
+    void makeSelIndexes   ( mmdb::PManager MMDB );
+    void deleteSelections ( mmdb::PManager MMDB );
+  };
 
-DefineStructure(SAtomPair);
-
-struct SAtomPair  {
-  PCAtom a1,a2;
-};
-
-// ==================================================================
-
-//   SDASelHandles is optionally used in MakeBonds(..), when
-// the latter works for hydrogen bond calculations.
-DefineStructure(SDASelHnds);
-
-struct SDASelHnds  {
-  int selHndDonor;
-  int selHndAcceptor;
-  int selHndHydrogen;
-  int selKey;
-  void getNewHandles    ( PCMMDBManager MMDB );
-  void makeSelIndexes   ( PCMMDBManager MMDB );
-  void deleteSelections ( PCMMDBManager MMDB );
-};
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_TYPES_H
